#!/usr/bin/env python
## This is an MPEG frame generator
## L. Nobre G.
## 2004

import sys, os, string
from timefuncs import *

story = {
	1: "film002.mp",
	2: 240,
	3: [ -1 ],
	4: [ 1 ],
	5: [ linfunc ]
	}
sourcedirectory = "."
prevlastframi = 0
firstframeind = prevlastframi+1
originalfrstr = "0000"
framstrnumdig = len( originalfrstr )
conv_file = open( "central.sh" ).read()
mpgencile = open( "central.en" ).read()
parameterbasestr = "Parameter"

mpostfilename = story[1] 
print "    Using " + mpostfilename
totalframenum = story[2]
lastframindex = prevlastframi+totalframenum
for k in range( 1, totalframenum+1 ):
	actualindexbas = str( k + prevlastframi ) 
	actualindexpad = originalfrstr[:framstrnumdig-\
				       len( actualindexbas )]
	actualindexstr = actualindexpad + actualindexbas
	mirrorindexbas = str( prevlastframi +\
			      2*totalframenum - k + 1 ) 
	mirrorindexpad = originalfrstr[:framstrnumdig-\
				       len( mirrorindexbas )] 
	mirrorindexstr = mirrorindexpad + mirrorindexbas
	tmpmpost = open( "frame%s.mp" % actualindexstr, 'w' )
	mpostfile = open( mpostfilename )
	sourcestring = mpostfile.read()			
	mpostfile.close()
	for j in range( len( story[3] ) ):
		lowparamlimit = story[3][j]
		higparamlimit = story[4][j]
		actualparamval = story[5][j]( lowparamlimit,\
						 higparamlimit,\
						 totalframenum, k )
		actualparamstr = "%f" % actualparamval
		sourcestring = sourcestring.replace( parameterbasestr+\
						     chr(65+j),\
						     actualparamstr )

	tmpmpost.write( sourcestring )
	tmpmpost.close()
	tmp_conv = open( "conv_%s.sh" % actualindexstr, 'w' )
	fir_file = conv_file.replace( 'TheFrameNumber',\
				      actualindexstr )
	tmp_conv.write( fir_file.replace( 'MirrorTimeReversed',\
					  mirrorindexstr ) )
	tmp_conv.close()

prevlastframi = lastframindex

tmpencod = open( "encode.Params", 'w' )
actualindexbas = str( lastframindex ) 
actualindexpad = originalfrstr[:framstrnumdig-len( actualindexbas )] 
actualindexstr = actualindexpad + actualindexbas
replacedencile = mpgencile.replace( 'LastFrameIndexStr', actualindexstr )
actualindexbas = str( firstframeind ) 
actualindexpad = originalfrstr[:framstrnumdig-len( actualindexbas )] 
actualindexstr = actualindexpad + actualindexbas
tmpencod.write( replacedencile.replace( 'FirstFrameIndexStr',actualindexstr ))
tmpencod.close()

